package org.processmining.plugins.astar.petrinet.impl;

import java.util.Map;

import nl.tue.astar.impl.DijkstraTail;
import nl.tue.astar.impl.State;
import nl.tue.astar.impl.memefficient.TailInflater;
import nl.tue.astar.util.ShortShortMultiset;
import nl.tue.storage.CompressedHashSet;
import nl.tue.storage.Deflater;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.classification.XEventClasses;
import org.deckfour.xes.model.XLog;
import org.processmining.models.graphbased.directed.petrinet.InhibitorNet;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.ResetInhibitorNet;
import org.processmining.models.graphbased.directed.petrinet.ResetNet;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.models.semantics.petrinet.Marking;
import org.processmining.plugins.connectionfactories.logpetrinet.TransEvClassMapping;

public class PDelegate extends AbstractPDelegate<DijkstraTail> {

	private final DijkstraTail compressor;
	private final boolean allMarkingsAreFinal;

	public PDelegate(Petrinet net, XLog log, XEventClasses classes, TransEvClassMapping map,
			Map<Transition, Integer> mapTrans2Cost, Map<XEventClass, Integer> mapEvClass2Cost, int delta,
			boolean allMarkingsAreFinal, Marking... set) {
		super(net, log, classes, map, mapTrans2Cost, mapEvClass2Cost, delta, set);
		this.allMarkingsAreFinal = allMarkingsAreFinal;

		compressor = DijkstraTail.EMPTY;
	}

	public PDelegate(ResetNet net, XLog log, XEventClasses classes, TransEvClassMapping map,
			Map<Transition, Integer> mapTrans2Cost, Map<XEventClass, Integer> mapEvClass2Cost, int delta,
			boolean allMarkingsAreFinal, Marking... set) {
		super(net, log, classes, map, mapTrans2Cost, mapEvClass2Cost, delta, set);
		this.allMarkingsAreFinal = allMarkingsAreFinal;

		compressor = DijkstraTail.EMPTY;
	}

	public PDelegate(InhibitorNet net, XLog log, XEventClasses classes, TransEvClassMapping map,
			Map<Transition, Integer> mapTrans2Cost, Map<XEventClass, Integer> mapEvClass2Cost, int delta,
			boolean allMarkingsAreFinal, Marking... set) {
		super(net, log, classes, map, mapTrans2Cost, mapEvClass2Cost, delta, set);
		this.allMarkingsAreFinal = allMarkingsAreFinal;

		compressor = DijkstraTail.EMPTY;
	}

	public PDelegate(ResetInhibitorNet net, XLog log, XEventClasses classes, TransEvClassMapping map,
			Map<Transition, Integer> mapTrans2Cost, Map<XEventClass, Integer> mapEvClass2Cost, int delta,
			boolean allMarkingsAreFinal, Marking... set) {
		super(net, log, classes, map, mapTrans2Cost, mapEvClass2Cost, delta, set);
		this.allMarkingsAreFinal = allMarkingsAreFinal;

		compressor = DijkstraTail.EMPTY;
	}

	public DijkstraTail createInitialTail(PHead head) {
		return DijkstraTail.EMPTY;
	}

	public TailInflater<DijkstraTail> getTailInflater() {
		return compressor;
	}

	public Deflater<DijkstraTail> getTailDeflater() {
		return compressor;
	}

	public void setStateSpace(CompressedHashSet<State<PHead, DijkstraTail>> statespace) {

	}

	public boolean isFinal(ShortShortMultiset marking) {
		if (allMarkingsAreFinal) {
			return true;
		} else {
			if (finalMarkings.size() > 0) {
				return super.isFinal(marking);
			} else {
				return !hasEnabledTransitions(marking);
			}

		}
	}

}
