/**
 * 
 */
package org.processmining.plugins.petrinet.replayer.algorithms.costbasedcomplete.rpstwrapper;


/**
 * @author aadrians
 *
 */
public class RPSTNodeWSiblings {
	/**
	 * parent node
	 */
	private RPSTNodeWSiblings parent = null;
	
	/**
	 * the next sibling node
	 */
	private RPSTNodeWSiblings nextSibling = null;
	
	/**
	 * the previous sibling node
	 */
	private RPSTNodeWSiblings prevSibling = null;
	
	/**
	 * entry of the fragment in encoded form
	 */
	private int entry;
	
	/**
	 * exit of the arc in encoded form
	 */
	private int exit;
	
	/**
	 * fragment type
	 */
	private RPSTFragmentType fragmentType;
	
	/**
	 * The only allowed constructor
	 * 
	 * @param entry
	 * @param exit
	 * @param fragmentType
	 */
	public RPSTNodeWSiblings(int entry, int exit, RPSTFragmentType fragmentType){
		this.entry = entry;
		this.exit = exit;
		this.fragmentType = fragmentType;
	}
		
	@SuppressWarnings("unused")
	private RPSTNodeWSiblings(){}

	/**
	 * @return the parent
	 */
	public RPSTNodeWSiblings getParent() {
		return parent;
	}

	/**
	 * @param parent the parent to set
	 */
	public void setParent(RPSTNodeWSiblings parent) {
		this.parent = parent;
	}

	/**
	 * @return the nextSibling
	 */
	public RPSTNodeWSiblings getNextSibling() {
		return nextSibling;
	}

	/**
	 * @param nextSibling the nextSibling to set
	 */
	public void setNextSibling(RPSTNodeWSiblings nextSibling) {
		this.nextSibling = nextSibling;
	}

	/**
	 * @return the prevSibling
	 */
	public RPSTNodeWSiblings getPrevSibling() {
		return prevSibling;
	}

	/**
	 * @param prevSibling the prevSibling to set
	 */
	public void setPrevSibling(RPSTNodeWSiblings prevSibling) {
		this.prevSibling = prevSibling;
	}

	/**
	 * @return the entry
	 */
	public int getEntry() {
		return entry;
	}

	/**
	 * @param entry the entry to set
	 */
	public void setEntry(int entry) {
		this.entry = entry;
	}

	/**
	 * @return the exit
	 */
	public int getExit() {
		return exit;
	}

	/**
	 * @param exit the exit to set
	 */
	public void setExit(int exit) {
		this.exit = exit;
	}

	/**
	 * @return the fragmentType
	 */
	public RPSTFragmentType getFragmentType() {
		return fragmentType;
	}

	/**
	 * @param fragmentType the fragmentType to set
	 */
	public void setFragmentType(RPSTFragmentType fragmentType) {
		this.fragmentType = fragmentType;
	}

	
}
